part of flutter_widget_model;

/// You can use the Collection only within HookWidget.
///
/// It is possible to specify an initial value by specifying [initialData].
IDataCollection useCollection({List<Map<String, dynamic>> initialData}) {
  return use(_CollectionHook(initialData: initialData));
}

class _CollectionHook extends Hook<TemporaryCollection> {
  final List<Map<String, dynamic>> initialData;
  _CollectionHook({this.initialData});
  @override
  _CollectionHookState createState() => _CollectionHookState();
}

class _CollectionHookState
    extends HookState<TemporaryCollection, _CollectionHook> {
  TemporaryCollection _collection;
  @override
  void initHook() {
    super.initHook();
    if (this.hook.initialData != null) {
      this._collection = TemporaryCollection.fromList(this.hook.initialData);
    } else {
      this._collection = TemporaryCollection();
    }
    this._collection?.listen(this._listener);
  }

  void _listener(TemporaryCollection state) {
    setState(() {});
  }

  @override
  void dispose() {
    super.dispose();
    this._collection?.unlisten(this._listener);
    this._collection?.dispose();
  }

  @override
  TemporaryCollection build(BuildContext context) {
    return this._collection;
  }
}
